# Patch file for Keen - use with CK6PATCH.EXE

%ext ck6

%version 1.0
%abort
%version 1.5
%abort
%version cga-1.0
%abort
%version cga-1.4
%abort
%version cga-1.5
%abort

%version 1.4

#%gamemaps custmaps.ck6
%maphead MTEMP.TMP

# Load the modified graphics
%egadict EGADICT.CK6
%egahead EGAHEAD.CK6

#Patch the sound header:
%patchfile $20C50 "AUDIOHHD.CK6"

# Not needed with patch skipping Huffman decompression - see further below.
#Patch the sound dictionary:
#%patchfile $36EEE "AUDIODCT.CK6"

#Patch tile properties:
%patchfile $25212 TILEINFO.CK6

#Skip creature question
%patch $1CC88 $90 $90

#Map Keen's initial direction:

#%patch $CFB8 $0000W #H
#%patch $CFBD $0000W #V

#Keen 6 Music
#Song values:
#00 = A World of Wonderment  01 = Brer Tar
#02 = To the Future          03 = Faster
#04 = Space Funk             05 = Aliens Ate My Babysitter
#06 = Ominous                07 = Metal
#08 = Mamba Snake

#Music swaps:
%patch $3103E $0005W #Map
              $0001W #Bloogwaters Crossing
              $0003W #Guard Post One
              $0008W #First Dome of Darkness
              $0008W #Second Dome of Darkness
              $0008W #Bloogdome
              $0003W #Bloogton Manufacturing
              $0005W #Bloogton Tower
              $0007W #Bloogfoods, Inc.
              $0007W #Guard Post 2
              $0001W #Bloogville
              $0005W #BASA
              $0002W #Guard Post 3
              $0004W #Bloogbase Recreational District
              $0004W #Bloogbase Management District
              $0006W #Bloog Control Center
              $0005W #Blooglab Space Station
              $0000W #Bean-with-Bacon Megarocket
              $0000W #High Scores
              $0005W #Not a part of stock Keen 6

#Other music played: (Values here are numbers of LEVELs whose music are used)
%patch $563F $0001W #Star wars text
%patch $E33C $0008W #Molly ending

#Displayed when Keen doesn't make it past a level:
%patch $30F73 "You didn't survive" $00
%patch $30F8B "Retry" $00
%patch $30F95 "Go to The Blog Planet" $00

#Level names:

#0
%patch $1EF40 "Blog Planet" $00
%patch $1F110 "Keen visits the" $0A
              "Blog Planet" $00
#1
%patch $1EF50 "Blog Lava Stream" $00
%patch $1F130 "Keen hears the noise" $0A
              "of the Blog Lava Stream" $00
#2
%patch $1EF70 "The Guard Post" $00
%patch $1F160 "Keen introduces himself" $0A
              "in The Guard Post" $00
#3
%patch $1EF80 "Dome of Outer Space" $00
%patch $1F190 "Keen enters carefully" $0A
              "the Dome of Outer Space" $00
#4
%patch $1EFA0 "The Lava Cave" $00
%patch $1F1C0 "Keen feels hot in" $0A
              "The Lava Cave" $00
#5
%patch $1EFC0 "Dome of Spikes" $00
%patch $1F1F0 "Keen enters carelessly" $0A
              "the Dome of Spikes" $00
#6
%patch $1EFD0 "Blog Tree Wall" $00
%patch $1F220 "Keen climbs the" $0A
              "Blog Tree Wall" $00
#7
%patch $1EFF0 "The Blog Tower" $00
%patch $1F250 "Keen wonders in" $0A
              "The Blog Tower" $00
#8
%patch $1F000 "The Blog Factory" $00
%patch $1F270 "Keen senses the smell" $0A
              "in The Blog Factory" $00
#9
%patch $1F020 "Confusion Arena" $00
%patch $1F2A0 "Keen gets dizzed in" $0A
              "the Confusion Arena" $00
#10
%patch $1F030 "The Blog Labs" $00
%patch $1F2D0 "Keen becomes curious" $0A
              "in The Blog Labs" $00
#11
#%patch $1F040 "BASA" $00
%patch $1F300 "Keen wanders into BASA" $00

#12
%patch $1F050 "The Blog" $0A
              "Experimental Desert" $00
%patch $1F350 "Keen gets surpised" $0A
              "in the desert" $00

#13
%patch $1F070 "The Blog Base" $0A
              "Of Outer Space" $00
%patch $1F380 "Keen flies to The Blog" $0A
              "Base Of Outer Space" $00
#14
%patch $1F090 "Outer Space" $0A
              "Secured Zone" $00
%patch $1F3C0 "Keen takes a risk in" $0A
              "the Secured Zone" $00
#15
%patch $1F0B0 "Dome of Evil" $00
%patch $1F400 "Keen looks for Molly" $0A
              "in the Dome of Evil" $00
#16
%patch $1F0D0 "Base Of Unknown" $00
%patch $1F440 "Keen checks the items" $0A
              "on the Base Of Unknown" $00

#19:
#This uses freed space originally intended
#for Huffman decompression (see further below).
#Level name pointer overrides are used first.
%patch $324FE $30D361BERL
%patch $32562 $30D361CERL

%patch $36EEE "Metro Satellite" $00
%patch $36EFE "Keen finally discovers" $0A
              "the Metro Satellite" $00

#Allow access to level 19 from the world map
%patch $D021 $13

#Grabbiter

%patch $3301A "Hmm... a Grabbiter blocks" $0A
              "the path. He says," $0A
          $22 "Hey, I'm quite hungry" $0A
              "at the moment..." $22 $00

%patch $33071 "The Grabbiter grabs" $0A
              "the gigantic sandwich," $0A
              "downs it in one bite," $0A
              "and says," $0A
          $22 "Hmm... I think" $0A
              "it's sleep time..." $22 $00

#Rocket passcard

%patch $3261A $0A "How have I got here" $0A
              "without getting hit... oh," $0A
              "a passcard? I guess it" $0A
              "can be quite useful." $0A $00

#**********
#STATUS SCREEN
#**********

#Text:
#%patch $312BF "LOCATION" $00
#%patch $312C8 "SCORE" $00
#              "EXTRA" $00
#%patch $312EB "ITEMS" $00
#%patch $312D4 "LEVEL" $00
#              "Easy" $00
#              "Normal" $00
#              "Hard" $00
%patch $312F1 "GEMS" $00
              "AMMO" $00
              "KEENS" $00
              "1/100" $00

#**********
#STORY TEXT
#**********

%patchfile $1ED50 "STORY.CK6"

#*****************************
#LOADING SCREEN - EPISODE NAME
#*****************************

%patchfile $1FCA7 ck6load.bin 

#**********
#CHEATS
#**********

# Change max. level to warp to
%patch $31268 "19" # Part of dialog text, originally "18"
%patch $75B9 $13 # Was $12

#Free stuff (B + A + T)
#%patch $7617 $5F     #Disable
#Debug keys (A + 2 + Enter)
#%patch $8092 $EB     #Disable
#Disable ALL F10 cheats
#%patch $717B $CB        #K1n9_Duk3 fix: removed the pop instructions, just in case
#Memory test?
#%patch $73B0 $EB     #Disable
#Sprite test (F10 + T)
#%patch $6B08 $CB     #Disable
#Show secrets (F10 + Y)
#%patch $7017 $5F $5E #Disable
#             $5D $CB
#Border color (F10 + B)
#%patch $7192 $90 $90 #Disable
#Godmode (F10 + G)
#%patch $7292 $EB     #Disable
#Free Items (F10 + I)
#%patch $72EE $EB     #Disable
#%patch $731D $0000  #Keys (Of all kinds) given
#%patch $7329 $0000  #Shots given
#%patch $732C $0000  #Give all items
#%patch $7342 $0BB8  #Score increased by (Default 3000)
#Jump cheat (F10 + J)
#%patch $735B $EB     #Disable
#Clipping (F10 + N)
#%patch $73C4 $EB     #Disable
#Slow motion (F10 + S)
#%patch $7442 $EB     #Disable
#Add VBLs (F10 + V)
#%patch $74B2 $90 $90 #Disable
#Level warp (F10 + W)
#%patch $7442 $EB     #Disable
#%patch $753B $90 $90 #Disable

#Disable tedlevel cheat (sort of...).

#%patch $34D0A $2020w $2020w $2020w $2020w	# K1n9_Duk3 fix: added 'w's

#Disable nowait argument (again, sort of...).

#%patch $34D13 $2020 $2020 $2020

###
#Gik
###

#Walking
#%patch $33340 $0080W $0000W #Walking h\v speed 
#%patch $3335E $0080W $0000W #Walking h\v speed 
#%patch $3337C $0080W $0000W #Walking h\v speed


#Jump (And slide):
%patch $111DE $FFF0W #Left sp
%patch $111E5 $0010W #Right sp
%patch $111EA $FFD0W #Height

###
#Green Blooglet
###

#%patch $32F7C $017EW $017AW #Green Blooglet running 1
%patch $32F86 $000AW        #Animation speed

#%patch $32F9A $017FW $017BW #Green Blooglet running 2
%patch $32FA4 $000AW        #Animation speed

#%patch $32FB8 $0180W $017CW #Green Blooglet running 3
%patch $32FC2 $000AW        #Animation speed

#%patch $32FD6 $0181W $017DW #Green Blooglet running 4 [Got o 1]
%patch $32FE0 $000AW        #Animation speed

# Patch from K1n9_Duk3:
# Make cannon shots removable (Keen 6 v1.4 EGA)
%patch $113F5 $0003W

################################################################################
# Customized Screen Update Code For KEEN6 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E713
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $761Aw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E794
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A6CBw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A6CBw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################


##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK6 file to be compressed with a "dummy" Huffman dictionary.
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $12F97
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $CD67w		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $CD5Fw		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $CD67w		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $CD61w		#	push	word ptr chunkexplen+2
	$FF $36 $CD5Fw		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $C8EBw		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $15110713rl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $A97Dw $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $CD61w		#	push	word ptr chunkexplen+2
	$FF $36 $CD5Fw		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $C8EBw		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $CD67w		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# This leaves 183 bytes unused at $13002 to $130B8 (inclusive)

# With this code, the huffman tree for the audio data is no longer needed,
# so let's prevent the engine from "optimizing" the huffman tree. This frees
# up 1024 bytes in the data segment, great for adding new (near) strings or
# new object state definitions.

# Free up 1024 bytes at $36EEE (dseg:61BE):
%patch $12EA4 $EB $0F

%end
